<!doctype html>
<html>
<head>
    <title>Website translation support for translation.torproject.org | The Tor Project</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <meta name="monetization" content="$ilp.uphold.com/pYfXb92JBQN4">
    <link rel="stylesheet" href="../static/css/style.css?h=5fc6c25a">
    <link rel="stylesheet" href="../static/fonts/fontawesome/css/all.min.css?h=9d272f6a">
    <link rel="stylesheet" href="../static/pygments.css">
    <link rel="icon" type="image/x-icon" href="../static/images/favicon/favicon.ico">
    <link rel="icon" type="image/png" href="../static/images/favicon/favicon.png">
    <meta property="og:title" content="Website translation support for translation.torproject.org | Tor Project">
    <meta property="og:description" content="This summer I was working on a set of scripts that would make it possible to translate the Tor...">
    <meta property="og:image" content="https://blog.torproject.org/static/images/lead.png">
    <meta property="og:url" content="https://blog.torproject.org/website-translation-support-translationtorprojectorg/">
    <meta name="twitter:card" content="summary_large_image">
</head>
<body>
  <header>
    <nav>
      <a class="navbar-brand" href="../"><img alt="Tor Blog" src="../static/images/logo.png" /></a>
      <ul class="navbar-nav">
          <li><a href="https://www.torproject.org/about/history/">About</a></li>
          <li><a href="https://support.torproject.org/">Support</a></li>
          <li><a href="https://community.torproject.org/">Community</a></li>
          <li><a href="https://forum.torproject.org/">Forum</a></li>
          <li><a href="https://donate.torproject.org/">Donate</a></li></ul>
    </nav>
  </header>
  <section class="content">
    <main>
  <article class="blog-post">
      <h1 class="title">
        Website translation support for translation.torproject.org
      </h1>
    <p class="meta">by Runa | September 20, 2009</p>
    <picture>
      <source media="(min-width:415px)" srcset="../static/images/lead.webp" type="image/webp">
<source srcset="../static/images/lead_small.webp" type="image/webp">

      <img class="lead" src="../static/images/lead.png">
    </picture>
    <div class="body">
      <link rel="stylesheet" href="../static/css/legacy.css?h=21ddbb2d">
      <p>This summer I was working on a set of scripts that would make it possible to translate the <a href="https://www.torproject.org/" rel="nofollow">Tor Project website</a> via <a href="http://translate.sourceforge.net/wiki/pootle" rel="nofollow">Pootle</a> on <a href="http://translation.torproject.org" rel="nofollow">translation.torproject.org</a>. The website is based on a set of .wml files, but Pootle only takes files in the .pot and po format. The goal was to find a solution that would make it easy to not only translate from .wml to .po and back, but enable us to convert and keep the already translated documents.</p>

<p>The solution that I chose was to use the <a href="http://po4a.alioth.debian.org/" rel="nofollow">po4a framework</a> in a set of scripts. The first script, <a href="https://tor-svn.freehaven.net/svn/website/trunk/wml2po.sh" rel="nofollow">wml2po.sh</a>, converts from .wml to .po and adds the correct charset, encoding and copyright holder. The script also checks to see which .po files need to be updated and which don't. The second script, <a href="https://tor-svn.freehaven.net/svn/website/trunk/po2wml.sh" rel="nofollow">po2wml.sh</a> writes the translated documents, i.e. converts from .po back to .wml. I also documented the things one would need to know before using the scripts, as well as the process of converting already translated documents. See the <a href="https://tor-svn.freehaven.net/svn/translation/trunk/tools/gsoc09/HOWTO" rel="nofollow">howto</a> and the <a href="https://tor-svn.freehaven.net/svn/translation/trunk/tools/gsoc09/README" rel="nofollow">readme</a>.</p>

<p>The project did not come without its challenges, and it took time before I got on the right track and found a solution that everyone was happy with. I looked at different scripts and SVN hooks before I settled on having two scripts that can be run at any time by anyone. In addition to that, my mentor was travelling a lot and communication was not very frequent. However, I do feel that I learned a lot and, at the same time, the communication with other GSoC students was a great help.</p>

<p>Overall, I'm pleased with how GSoC turned out. I am looking forward to seeing my code be put to use and to start working on other projects for Tor.</p>

    </div>
  <div class="categories">
    <ul><li>
        <a href="../category/internships">
          internships
        </a>
      </li><li>
        <a href="../category/localization">
          localization
        </a>
      </li></ul>
  </div>
  <div class="comments">
      <h2>Comments</h2>
      <p>Please note that the comment area below has been archived.</p>
      <a id="comment-4091"></a>
<div class="comment-meta-filler">
<!-- Comment -->
<article id="comment-4091" class="contextual-region comment js-comment by-anonymous" id="comment-">
  <footer class="comment__meta">
    <div class="comment-header">
      <p class="comment__submitted"><span>Anonymous (not verified)</span> said:</p>
      <p class="date-time">January 24, 2010</p>
    </div>
    <a href="#comment-4091">Permalink</a>
  </footer>
  <div class="content">
      <h3><a href="#comment-4091" class="permalink" rel="bookmark">Interesting</a></h3>
      <div></div>
            <div class="field field--name-comment-body field--type-text-long field--label-hidden field--item"><p>Interesting project.currently i am very busy but want to take part in this project in the future. good luck!!</p>
<p>___________<br />
Omidiu, part of the <a href="http://www.traduceriautorizate.biz" rel="nofollow">Traduceri</a> team.</p>
</div>
  </div>
</article>
<!-- Comment END -->
  </div>
  </article>

</main>
    <aside class="sidebar">
<!-- ##SIDEBAR## -->
</aside>
  </section>
  <footer><div class="row download">
    <div class="col circles"></div>
    <div class="col link">
        <h3>Download Tor Browser</h3>
        <p>Download Tor Browser to experience real private browsing without tracking, surveillance, or censorship.</p>
        <a class="btn" href="https://www.torproject.org/download/">Download Tor Browser <i class="fas fa-arrow-down-png-purple"></i></a>
    </div>
</div>
<div class="row social">
    <div class="col newsletter">
        <h3>Subscribe to our Newsletter</h3>
        <p>Get monthly updates and opportunities from the Tor Project:</p>
        <p class="w"><a class="btn btn-dark" role="button" href="https://newsletter.torproject.org/">Sign up</a></p>
    </div>
    <div class="col links">
        <div class="row">
            <h4><a target="_blank" href="https://www.facebook.com/TorProject/"><i class="fab fa-facebook"></i></a></h4>
            <h4><a target="_blank" href="https://mastodon.social/@torproject" rel="me"><i class="fab fa-mastodon"></i></a></h4>
            <h4><a target="_blank" href="https://twitter.com/torproject"><i class="fab fa-twitter"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://www.instagram.com/torproject"><i class="fab fa-instagram"></i></a></h4>
            <h4><a target="_blank" href="https://www.linkedin.com/company/tor-project"><i class="fab fa-linkedin"></i></a></h4>
            <h4><a target="_blank" href="https://github.com/torproject"><i class="fab fa-github"></i></a></h4>
        </div>
        <div class="row">
            <h4><a target="_blank" href="https://t.me/torproject"><i class="fab fa-telegram"></i></a></h4>
        </div>
    </div>
</div>
<div class="row notice">
    <p>Trademark, copyright notices, and rules for use by third parties can be found in our <a href="https://www.torproject.org/about/trademark/">FAQ</a>.</p>
</div></footer>
</body>
</html>
